Package org.apache.sis.metadata.iso.extent

# Class DefaultVerticalExtent

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultVerticalExtent

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `VerticalExtent`

public class DefaultVerticalExtent extends ISOMetadata implements VerticalExtent
Vertical domain of dataset. The following properties are mandatory in a well-formed metadata according ISO 19115:
`EX_VerticalExtent` `├─minimumValue……` The lowest vertical extent contained in the dataset. `├─maximumValue……` The highest vertical extent contained in the dataset. `└─verticalCRS………` Information about the vertical coordinate reference system to which the maximum and minimum elevation values are measured. The CRS identification includes unit of measure.
In addition to the standard properties, SIS provides the following methods:

- `setBounds(Envelope)` for setting the extent from the given envelope.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
- Coordinate Reference System can not be specified by identifier only; they have to be specified in full. See SIS-397.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultVerticalExtent()`
  Constructs an initially empty vertical extent.
  `DefaultVerticalExtent(double minimumValue, double maximumValue, VerticalCRS verticalCRS)`
  Creates a vertical extent initialized to the specified values.
  `DefaultVerticalExtent(VerticalExtent object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultVerticalExtent`
  `castOrCopy(VerticalExtent object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Double`
  `getMaximumValue()`
  Returns the highest vertical extent contained in the dataset.
  `Double`
  `getMinimumValue()`
  Returns the lowest vertical extent contained in the dataset.
  `VerticalCRS`
  `getVerticalCRS()`
  Provides information about the vertical coordinate reference system to which the maximum and minimum elevation values are measured.
  `void`
  `intersect(VerticalExtent other)`
  Sets this vertical extent to the intersection of this extent with the specified one.
  `void`
  `setBounds(Envelope envelope)`
  Sets this vertical extent to values inferred from the specified envelope.
  `void`
  `setMaximumValue(Double newValue)`
  Sets the highest vertical extent contained in the dataset.
  `void`
  `setMinimumValue(Double newValue)`
  Sets the lowest vertical extent contained in the dataset.
  `void`
  `setVerticalCRS(VerticalCRS newValue)`
  Sets the information about the vertical coordinate reference system to which the maximum and minimum elevation values are measured.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultVerticalExtent

    public DefaultVerticalExtent()
    Constructs an initially empty vertical extent.

  - ### DefaultVerticalExtent

    public DefaultVerticalExtent(double minimumValue, double maximumValue, VerticalCRS verticalCRS)
    Creates a vertical extent initialized to the specified values.
    Parameters:
      `minimumValue` - the lowest vertical extent contained in the dataset, or `Double​.NaN` if none.
      `maximumValue` - the highest vertical extent contained in the dataset, or `Double​.NaN` if none.
      `verticalCRS` - the information about the vertical coordinate reference system, or `null`.

  - ### DefaultVerticalExtent

    public DefaultVerticalExtent(VerticalExtent object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(VerticalExtent)`

- ## Method Details

  - ### castOrCopy

    public static DefaultVerticalExtent castOrCopy(VerticalExtent object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultVerticalExtent`, then it is returned unchanged.
    - Otherwise a new `DefaultVerticalExtent` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getMinimumValue

    public Double getMinimumValue()
    Returns the lowest vertical extent contained in the dataset.
    Specified by:
      `getMinimumValue` in interface `VerticalExtent`
    Returns:
      the lowest vertical extent, or `null`.

  - ### setMinimumValue

    public void setMinimumValue(Double newValue)
    Sets the lowest vertical extent contained in the dataset.
    Parameters:
      `newValue` - the new minimum value.

  - ### getMaximumValue

    public Double getMaximumValue()
    Returns the highest vertical extent contained in the dataset.
    Specified by:
      `getMaximumValue` in interface `VerticalExtent`
    Returns:
      the highest vertical extent, or `null`.

  - ### setMaximumValue

    public void setMaximumValue(Double newValue)
    Sets the highest vertical extent contained in the dataset.
    Parameters:
      `newValue` - the new maximum value.

  - ### getVerticalCRS

    public VerticalCRS getVerticalCRS()
    Provides information about the vertical coordinate reference system to which the maximum and minimum elevation values are measured. The CRS identification includes unit of measure.
    Specified by:
      `getVerticalCRS` in interface `VerticalExtent`
    Returns:
      the vertical CRS, or `null`.
    See Also:
      - SIS-397

  - ### setVerticalCRS

    public void setVerticalCRS(VerticalCRS newValue)
    Sets the information about the vertical coordinate reference system to which the maximum and minimum elevation values are measured.
    Parameters:
      `newValue` - the new vertical CRS.

  - ### setBounds

    public void setBounds(Envelope envelope) throws TransformException
    Sets this vertical extent to values inferred from the specified envelope. The envelope can be multi-dimensional, in which case the envelope CRS must have a vertical component.

    Note: this method is available only if the referencing module is on the classpath.

    Parameters:
      `envelope` - the envelope to use for setting this vertical extent.
    Throws:
      `UnsupportedOperationException` - if the referencing module is not on the classpath.
      `TransformException` - if the envelope can not be transformed to a vertical extent.
    See Also:
      - `DefaultExtent​.addElements(Envelope)`
      - `DefaultGeographicBoundingBox​.setBounds(Envelope)`
      - `DefaultTemporalExtent​.setBounds(Envelope)`

  - ### intersect

    public void intersect(VerticalExtent other) throws IllegalArgumentException
    Sets this vertical extent to the intersection of this extent with the specified one. The vertical datum must be the same (ignoring metadata) for both extents; this method does not perform datum shift. However this method can perform unit conversions.

    If there is no intersection between the two extents, then this method sets both minimum and maximum values to Double.NaN. If either this extent or the specified extent has NaN bounds, then the corresponding bounds of the intersection result will also be NaN.

    Parameters:
      `other` - the vertical extent to intersect with this extent.
    Throws:
      `IllegalArgumentException` - if the two extents do not use the same datum, ignoring metadata.
    Since:
      0.8
    See Also:
      - `Extents​.intersection(VerticalExtent, VerticalExtent)`
      - `GeneralEnvelope​.intersect(Envelope)`